'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _curry = require('lodash/curry');

var _curry2 = _interopRequireDefault(_curry);

var _flow = require('lodash/flow');

var _flow2 = _interopRequireDefault(_flow);

var _groupBy = require('lodash/fp/groupBy');

var _groupBy2 = _interopRequireDefault(_groupBy);

var _keyBy = require('lodash/fp/keyBy');

var _keyBy2 = _interopRequireDefault(_keyBy);

var _mapValues2 = require('lodash/fp/mapValues');

var _mapValues3 = _interopRequireDefault(_mapValues2);

var _omitBy = require('lodash/omitBy');

var _omitBy2 = _interopRequireDefault(_omitBy);

var _property = require('lodash/fp/property');

var _property2 = _interopRequireDefault(_property);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _isLicenseWhitelisted = require('./is-license-whitelisted');

var _isLicenseWhitelisted2 = _interopRequireDefault(_isLicenseWhitelisted);

var _isModuleWhitelisted2 = require('./is-module-whitelisted');

var _isModuleWhitelisted3 = _interopRequireDefault(_isModuleWhitelisted2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const mapValues = _mapValues3.default.convert({ cap: false });

const _groupByNameByVersion = (0, _flow2.default)((0, _groupBy2.default)('name'), mapValues((0, _keyBy2.default)('version')));

const _addOtherUsedVersions = (0, _curry2.default)((moduleByNameByVersion, module) => {
  const name = module.name,
        version = module.version;

  const byVersion = (0, _omit2.default)(moduleByNameByVersion[name], version);
  return _extends({}, module, { otherUsedVersions: byVersion });
});

exports.default = (0, _curry2.default)((licenseWhitelist, exceptionWhitelist, moduleWhitelist, moduleMap) => {
  const isModuleWhitelisted = (0, _isModuleWhitelisted3.default)(moduleWhitelist);
  const isModuleLicenseWhitelisted = (0, _flow2.default)((0, _property2.default)('licenseDescriptor'), (0, _isLicenseWhitelisted2.default)(licenseWhitelist, exceptionWhitelist));

  const moduleByNameByVersion = _groupByNameByVersion(moduleMap);

  const withoutWithelistedLicenses = (0, _omitBy2.default)(moduleMap, isModuleLicenseWhitelisted);
  const withoutWithelistedModules = (0, _omitBy2.default)(withoutWithelistedLicenses, isModuleWhitelisted);
  return mapValues(_addOtherUsedVersions(moduleByNameByVersion), withoutWithelistedModules);
});