'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _spdx = require('spdx');

var _spdx2 = _interopRequireDefault(_spdx);

var _curry = require('lodash/curry');

var _curry2 = _interopRequireDefault(_curry);

var _spdx3 = require('../spdx');

var _spdx4 = _interopRequireDefault(_spdx3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _curry2.default)((licenseWhitelist, exceptionWhitelist, licenseDescription) => {
  const inWhitelist = license => Array.from(licenseWhitelist).includes(license);

  const inExceptionWhitelist = exception => Array.from(exceptionWhitelist).includes(exception);

  if (Array.isArray(licenseDescription)) {
    return licenseDescription.length > 0 && licenseDescription.some(inWhitelist);
  }

  if (licenseDescription != null && _spdx2.default.valid(licenseDescription)) {
    const spdxAst = _spdx2.default.parse(licenseDescription);
    const evaluate = (0, _spdx4.default)(inWhitelist, inExceptionWhitelist);
    return evaluate(spdxAst);
  }

  return inWhitelist(licenseDescription);
});