'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _curry = require('lodash/curry');

var _curry2 = _interopRequireDefault(_curry);

var _some = require('lodash/some');

var _some2 = _interopRequireDefault(_some);

var _sortBy = require('lodash/sortBy');

var _sortBy2 = _interopRequireDefault(_sortBy);

var _isEqual = require('lodash/fp/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _isMatchWith = require('lodash/fp/isMatchWith');

var _isMatchWith2 = _interopRequireDefault(_isMatchWith);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _matchLicenses(whitelistedValue, actualValue, propertyName) {
  if (propertyName === 'licenseDescriptor') {
    const whitelistedLicensesAsArray = (0, _sortBy2.default)([].concat(whitelistedValue));
    const actualLicensesAsArray = (0, _sortBy2.default)([].concat(actualValue));

    return (0, _isEqual2.default)(whitelistedLicensesAsArray, actualLicensesAsArray);
  }
  return undefined;
}

exports.default = (0, _curry2.default)((moduleWhitelist, module) => {
  const moduleProps = {
    name: module.name || null,
    version: module.version || null,
    licenseDescriptor: module.licenseDescriptor || null
  };
  const matchesModule = (0, _isMatchWith2.default)(_matchLicenses, moduleProps);

  return (0, _some2.default)(moduleWhitelist, matchesModule);
});