'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (text) {
  const matchesText = expression => expression.test(text);

  const someExpressionMatchesText = regularExpressions => (0, _some2.default)(regularExpressions, matchesText);

  const addSuffix = license => `${license}*`;

  const guessLicenses = (0, _flow2.default)((0, _pickBy2.default)(someExpressionMatchesText), _keys2.default, (0, _map2.default)(addSuffix));

  return guessLicenses(licenseMatchingMap);
};

var _flow = require('lodash/flow');

var _flow2 = _interopRequireDefault(_flow);

var _pickBy = require('lodash/fp/pickBy');

var _pickBy2 = _interopRequireDefault(_pickBy);

var _map = require('lodash/fp/map');

var _map2 = _interopRequireDefault(_map);

var _some = require('lodash/some');

var _some2 = _interopRequireDefault(_some);

var _keys = require('lodash/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const specialWords = ['licen[sc]e'];

const licensePatternOfText = text => {
  let pattern = '';
  let isRegExpChar = false;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = text.replace(/\s+/g, ' ')[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      const char = _step.value;

      if (isRegExpChar) {
        if (char === '~') {
          isRegExpChar = false;
        } else {
          pattern += char;
        }
      } else {
        switch (false) {
          case char !== '~':
            isRegExpChar = true;
            break;
          case !char.match(/[A-Za-z]/):
            pattern += char;
            break;
          case !char.match(/\s/):
            pattern += '\\s+';
            break;
          case !char.match(/[0-9]/):
            pattern += `\\s*${char}?\\s*`;
            break;
          default:
            pattern += `\\s*\\${char}?\\s*`;
        }
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = specialWords[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      const specialWord = _step2.value;

      pattern = pattern.replace(new RegExp(specialWord, 'ig'), specialWord);
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  return new RegExp(pattern, 'i');
};

const licenseMatchingMap = {
  BSD: [/\bBSD\s+Licen[sc]e\b/i],
  'Apache-2.0': [/\bApache\s+Licen[sc]e\b([\s\S])*Version 2\.0/i],
  MIT: [/\bMIT\s+Licen[sc]e(d)?\b/i, /\bLicen[sc]e(:)?\s+MIT\b/i, licensePatternOfText(`\
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated
documentation files (the "Software"), to deal in the Software without restriction, including without
limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
the Software, and to permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial
portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\
`)],
  Unlicense: [/unlicense\.org/i],
  'Public-Domain': [/\bPublic\s+Domain\b/i],
  WTFPL: [/\bDO\s+WHAT\s+THE\s+FUCK\s+YOU\s+WANT\s+TO\s+PUBLIC\s+LICENSE\b/i],
  '#Chris-Andrews': [licensePatternOfText(`\
Copyright ~[0-9]{4}~ Chris Andrews. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, this list of
      conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright notice, this list
      of conditions and the following disclaimer in the documentation and/or other materials
      provided with the distribution.

THIS SOFTWARE IS PROVIDED BY CHRIS ANDREWS \`\`AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL CHRIS ANDREWS OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\
`)]
};