'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _child_process = require('child_process');

var _child_process2 = _interopRequireDefault(_child_process);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const execFile = _bluebird2.default.promisify(_child_process2.default.execFile);

// This function is intended to be used with yarn until a better option is available.
// Its dangerous to use because its ignoring any errors.
const execFileDangerously = (command, args, options) => new Promise(resolve => {
  const cb = (error, stdout) => resolve(stdout);
  _child_process2.default.execFile(command, args, options, cb);
});

const isYarnInUse = path => _fs2.default.existsSync(`${path}/yarn.lock`);

const getExecFile = modulePath => {
  if (isYarnInUse(modulePath)) {
    // eslint-disable-next-line no-console
    console.log('yarn.lock found. Suppressing errors coming from npm ls.');
    return execFileDangerously;
  }
  return execFile;
};

exports.default = (() => {
  var _ref = _asyncToGenerator(function* (dev, modulePath) {
    const options = {
      maxBuffer: 26 * 1024 * 1024,
      cwd: modulePath || process.cwd()
    };
    const _execFile = getExecFile(options.cwd);

    const stdout = yield _execFile('npm', ['list', '--json', '--long', dev ? '--dev' : '--prod'], options);

    return JSON.parse(stdout);
  });

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
})();