'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defaults3 = require('lodash/defaults');

var _defaults4 = _interopRequireDefault(_defaults3);

var _check = require('./check');

var _check2 = _interopRequireDefault(_check);

var _detect = require('./detect');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = (() => {
  var _ref = _asyncToGenerator(function* (whitelist, options) {
    var _defaults = (0, _defaults4.default)(options, {
      dev: false,
      path: null
    });

    const dev = _defaults.dev,
          path = _defaults.path;

    var _defaults2 = (0, _defaults4.default)(whitelist, {
      licenses: [],
      licenseExceptions: [],
      modules: []
    });

    const licenses = _defaults2.licenses,
          licenseExceptions = _defaults2.licenseExceptions,
          modules = _defaults2.modules;


    const dependencyTree = yield (0, _detect.readDependencyTree)(dev, path);
    const allModules = (0, _detect.extractModules)(dependencyTree);
    const violatingModules = (0, _check2.default)(licenses, licenseExceptions, modules, allModules);

    return {
      allModules,
      violatingModules
    };
  });

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
})();